%% This script is used to determine the correlations between the COVID-19 data in Singapore and the electricity demand.
%----Author: Guru Raghav Raman----
%Run after executing the script "Load_data.m".

%% Analyse correlations between COVID-19 case numbers and aggregate peak demand.
%%%%%%%% NEW CASES %%%%%%%%
% Normalized cross correlation between daily new cases and peak aggregate 
% demand of all 10246 consumers:
[c,lags] = xcorr(case_data(84:213,1),peak_total_demand(84:213)','normalized');
stem(lags,c)
xlabel('Lag (days)');

%Pearson's correlation coefficient and p-value
[rho,pval]=corr(case_data(84:213,1),peak_total_demand(84:213)')
%Spearman's correlation coefficient and p-value
[rho,pval]=corr(case_data(84:213,1),peak_total_demand(84:213)','Type','Spearman')

%%%%%%%% RECOVERED CASES %%%%%%%%
% Normalized cross correlation between daily recovered cases and peak 
% aggregate demand of all 10246 consumers:
[c,lags] = xcorr(case_data(84:213,2),peak_total_demand(84:213),'normalized');
stem(lags,c)
xlabel('Lag (days)');

%Pearson's correlation coefficient and p-value
[rho,pval]=corr(case_data(84:213,2),peak_total_demand(84:213)')
%Spearman's correlation coefficient and p-value
[rho,pval]=corr(case_data(84:213,2),peak_total_demand(84:213)','Type','Spearman')

%% Analyze before and during Circuit Breaker separately.
target_dates=84:158; %Before Circuit breaker: 23 Jan-6 April
% target_dates=159:213; %Circuit breaker begins on 7 Apr: 7 Apr-31 May

%%%%%%%% NEW CASES %%%%%%%%
%Pearson's correlation coefficient and p-value
[rho,pval]=corr(case_data(target_dates,1),peak_total_demand(target_dates)')
%Spearman's correlation coefficient and p-value
[rho,pval]=corr(case_data(target_dates,1),peak_total_demand(target_dates)','Type','Spearman')

%%%%%%%% RECOVERED CASES %%%%%%%%
%Pearson's correlation coefficient and p-value
[rho,pval]=corr(case_data(target_dates,2),peak_total_demand(target_dates)')
%Spearman's correlation coefficient and p-value
[rho,pval]=corr(case_data(target_dates,2),peak_total_demand(target_dates)','Type','Spearman')